#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PI (3.14159265358979323846)

double rate  = 8363;
double ends   = 1.5;
unsigned char sample[32000];

double freq1 = 261.62, amp1  = 1, env1[10][2] =   {
				{   0, 0   },
				{ 0.1, 1.0 },
				{   1, 0.3 },
				{ 1.5, 0   },
				{ 2.1, 0   } };

double freq2 = 19, amp2  = 10, env2[10][2] =   {
				{   0, 0   },
				{   1, 1.0 },
				{ 2.1, 0   } };

double envelope(double *env, double t)
{
	int	i;
	double	e;

	for (i = 0; i < 10; i++) {
		e = env[i+i+1];
		if (env[i+i+2] >= t) break;
	}
	e += (t-env[i+i])*(env[i+i+3]-e)/(env[i+i+2]-env[i+i]);
	return e;
}

int main()
{
	FILE	*fh;
	long	i, f;
	double	t, env, x;

	f = rate * ends;
	for (i = 0; i < f; i++) {
		t = i / rate;
		env = envelope(env2,t);
		x   = env * amp2 * sin (t * freq2 * 2 * PI);
		env = envelope(env1,t);
		x   = 127.0 * env * amp1 * sin (t * (freq1 + x) * 2 * PI);
		sample[i] = 128.0 + x;
	}

	fh = fopen("fm.sam","wb");
	fwrite(sample,1,i,fh);
	fclose(fh);

	return 0;
}

